package net.mcreator.voltage.procedures;

import net.minecraft.world.World;
import net.minecraft.world.Explosion;

import net.mcreator.voltage.VoltageModVariables;
import net.mcreator.voltage.VoltageModElements;

@VoltageModElements.ModElement.Tag
public class StorageBlockDestroyedByExplosionProcedure extends VoltageModElements.ModElement {
	public StorageBlockDestroyedByExplosionProcedure(VoltageModElements instance) {
		super(instance, 11);
	}

	public static void executeProcedure(java.util.HashMap<String, Object> dependencies) {
		if (dependencies.get("x") == null) {
			System.err.println("Failed to load dependency x for procedure StorageBlockDestroyedByExplosion!");
			return;
		}
		if (dependencies.get("y") == null) {
			System.err.println("Failed to load dependency y for procedure StorageBlockDestroyedByExplosion!");
			return;
		}
		if (dependencies.get("z") == null) {
			System.err.println("Failed to load dependency z for procedure StorageBlockDestroyedByExplosion!");
			return;
		}
		if (dependencies.get("world") == null) {
			System.err.println("Failed to load dependency world for procedure StorageBlockDestroyedByExplosion!");
			return;
		}
		int x = (int) dependencies.get("x");
		int y = (int) dependencies.get("y");
		int z = (int) dependencies.get("z");
		World world = (World) dependencies.get("world");
		if (!world.isRemote) {
			world.createExplosion(null, (int) x, (int) y, (int) z, (float) 4, Explosion.Mode.BREAK);
		}
		VoltageModVariables.MapVariables.get(world).Tmax = (double) ((VoltageModVariables.MapVariables.get(world).Tmax) - 2500000);
		VoltageModVariables.MapVariables.get(world).syncData(world);
	}
}
